<?php
/* ============================================================================
 *  bakcup_db, Version 1.1
 *  Copyright (c) 2007 MalCom
 * ---------------------------------------------------------------------------
 *  Script Launguage: PHP
 *    Script License: GPL
 *
 *             Autor: MalCom
 *            E-mail: malcom[at]o2[dot]pl
 *               www: http://malcom.pl
 *
 *           Created: 2005/09/11
 *     Last Modified: 2007/05/10
 *
 *   Script homepage: http://projects.malcom.pl/scripts/backup_db.xhtml
 * ---------------------------------------------------------------------------
 *
 *    Skrypt  backu_db  sluzly  do  tworzenia  kompletnej kopii bazy danych
 *    mySQL  wraz z jej struktura. Plik z backupem bazy zostaje wyslany, na
 *    podany  e-mail i/lub na serwer FTP. Przed wysylka mozliwosc kompresji
 *    sql'a  GZIPem.  Skrypt  posiada  mozliwosci konfiguracyjne okreslenia
 *    tworzonego zapytania sql, generowania raportu, etc...
 *
 * ============================================================================
 */

/*****************************************************************************/
// Konfiguracja

// dane bazy mySQL //
$db_host   = 'localhost';	// nazwa hosta;
$db_user   = 'user';		// nazwa usera;
$db_passwd = 'haslo';		// haslo usera;
$db_name   = 'baza';		// nazwa bazy, ktorej skyrpt ma wykonac kopie;

// glowne dane konfiguracji //
$nazwa_pliku = '';			// nazwa pliku z kopia bazy bez rozszerzenia np. backup_bazy,
							// jesli puste to zostanie przyjeta domyslna nazwa pliku:
							// NazwaBazy-[data].sql(.gz), np. baza2-[2005-09-14].sql(.gz);

	// 1 -wlaczone; 0 -wylaczone//
define('SEND_EMAIL',   0);	// wysylka kopi emailem (zalacznik);
define('SEND_FTP',     1);	// wysylka kopi na serwr ftp;
define('GZIP_FILE',    1);	// kompresja pliku kopi bazy GZIPem;

define('SQL_DROP',     1);	// dodanie DROP TABLE do zapytania sql;
define('SQL_IFNE',     0);	// dodanie IF NOT EXISTS do CREATE TABLE;
define('SQL_AUTO',     1);	// dodanie wartosci AUTO_INCREMENT;
define('SQL_FULL',     0);	// pelne dodania danych w zapytaniu sql;

define('RAPORT_FULL',  1);	// pelny raport z wszystkimi logami (sql, gzip, email, ftp..);
define('RAPORT_EMAIL', 1);	// wyslij raport emailem;
define('RAPORT_WWW',   1);	// wyswietl raport na www;

define('DEL_TMP',      2);	// usuniecie pliku z lokalnego serwera
							// 0 -nigdy nie usuwaj;
							// 1 -zawsze usun, po zakonczeniu dzialania skryptu niezaleznie od wyniku;
							// 2 -usun tylko gdy wyslano do wszytskich miejsc docelowych;

// dane obslugi emaila //
$e_mail  = 'you@mail.com';			// adres e-mail, na ktory bedzie wyslany plik backupu;
$e_name  = 'your_name';				// nazwa e-maila, np. swoje imie i nazwisko;
$e_temat = '[backup_db]: ' . $db_name; // temat emaila z backupem;

$e_rap_mail  = 'you@mail.com';		// adres e-mail, na ktory bedzie wyslany raport;
$e_rap_name  = 'your_name';			// nazwa e-maila, np. swoje imie i nazwisko;
$e_rap_temat = '[backup_db]: Raport z tworzenia backupu bazy ' . $db_name; // temat emaila z raportem;

// dane obslugi ftp'a //
$ftp_server    = 'ftp.domena.pl';	// adres serwera FTP, na ktory wyslac backup;
$ftp_user_name = 'login';			// nazwa uzytkownika serwera FTP;
$ftp_user_pass = 'haslo';			// haslo uzytkownika serwera FTP;
$ftp_sciezka   = '';				// sciezka do katalogu na ftpie gdzie ma byc przeslany backup;
									// jesli katalog (katalogi okreslone w sciezce) nie istnieja
									// lub nie mozna bedzie uzyskac dostepu do nich, to zostanie
									// przyjeta domyslna nazwa '/backup_db';
									// jesli puste to rowniez domyslna nazwa '/backup_db',
									// jesli nie istnieje domyslny katalog to zostanie utworzony;

/*****************************************************************************/

$time_skrypt_start = getmicrotime(); 	// czas startu skryptu;
$log_start = time_log() . "Rozpoczto wykonywanie backupa [skryptu]<br>";

// zwraca unixwoy czas z microsekundami;
function getmicrotime() {
	list($usec, $sec) = explode(" ",microtime());
	return ((float)$usec + (float)$sec);
}
// aktualna godzina dla loga;
function time_log() {
	$godz = " [".gmdate("H:i:s", time())."] ";
	return $godz;
}

$crlf = "\r\n"; // nowa linia;
$data = gmdate("Y-m-d", time());
$czas = gmdate("H:i:s", time());
$data_czas = $data .', '. $czas;

// nazwy plikow;
if ($nazwa_pliku == '') {
	$nazwa_pliku = $db_name .'-['. $data . '].sql';	// standardowa nazwa pliku;
} else {
	$nazwa_pliku = $nazwa_pliku . '.sql';
}

// gdy adres mysql to localhost, to ip bedzie takie jak php;
if ($db_host == "localhost") {
	$sql_ip = $_SERVER['SERVER_ADDR'];
	$sql_host = 'localhost [' . $_SERVER['SERVER_NAME'] .']';
} else {
	$sql_ip = gethostbyname($db_host);
	$sql_host = @gethostbyaddr($db_host);
	// jesli podano w $db_host adres domenowy to funkcja gethostbyaddr nic nie zwroci,
	// tylko wypluje warrning, dlatego @ i wtedy nazwa hosta jest taka jaka podano
	// w adresie, jesli podano w adresie IP wtedy funkcja pobierze nazwe hosta;
	if (!$sql_host) { $sql_host = $db_host; }
}

// adres i host ftpa;
if (SEND_FTP) {
	$ftp_ip = gethostbyname($ftp_server);
	$ftp_host = @gethostbyaddr($ftp_server);
	if (!$ftp_host) { $ftp_host=$ftp_server; }
}


$db_connect = @mysql_connect($db_host, $db_user, $db_passwd);
if (!$db_connect) {
	$log_sql .= time_log() . "<font color=red>Nie mona nawiza poczenia z serwerem MySQL</font><br>";
} else {
	$log_sql .= time_log() . "Nawizano poczenie z serwerem MySQL<br>";
	$log_sql .= time_log() . "Host: <b>$sql_host</b>, IP: <b>$sql_ip</b><br>";
	$log_sql .= time_log() . "Zalogowano si jako user <b>$db_user</b><br>";
	// wybierz baze;
	$db_select = @mysql_select_db($db_name);
	if (!$db_select) {
		$log_sql .= time_log() . "<font color=red>Nie mona wybra bazy <b>$db_name</b></font><br>";
		$sql_polaczenie = false;	// zatrzymaj
	} else {
		// poprawnie sie polaczono i wybrano baze;
		$log_sql .= time_log() . "Poprawnie wybrano baz <b>$db_name</b><br>";
		$sql_polaczenie = true;	// mozna tworzyc kopie bazy;
	}
}

if ($sql_polaczenie) {
// wyciaganie danych z bazy i zapis do pliku w czasie rzeczywistym;
// tworz zapytania sql do backupa;
	$plik_sql = fopen($nazwa_pliku, "w");
	flock($plik_sql, 2);
	$log_sql .= time_log() . "Utworzenie pliku sql <b>$nazwa_pliku</b><br>";
	$time_start = getmicrotime(); 	// czas startu tworzenia backupa;
	$log_sql .= time_log() . "Rozpoczcie pobierania danych z bazy i tworzenie zapytania sql<br>";
	$sql  = '# =================================================' . $crlf;
	$sql .= '#             Powered by backup_db 1.0' . $crlf;
	$sql .= '#     backup_db (c) MalCom, malcom[at]o2[dot]pl' . $crlf;
	$sql .= '#  Copyright (c) 2005 MalCom. All rights reserved.' . $crlf;
	$sql .= '# =================================================' . $crlf;
	$sql .= '#               Host: ' . $sql_host . $crlf;
	$sql .= '#                 IP: ' . $sql_ip . $crlf;
	$sql .= '#          Host info: ' . mysql_get_host_info() . $crlf;
	$sql .= '#     Server version: ' . mysql_get_server_info() . $crlf;
	$sql .= '#        PHP Version: ' . phpversion() . $crlf;
	$sql .= '# -------------------------------------------------' . $crlf;
	$sql .= '#  Zrzut bazy danych: ' . $db_name . $crlf;
	$sql .= '#       Wygenerowano: ' . $data_czas . ' GMT' . $crlf;
	$sql .= '# -------------------------------------------------' . $crlf;
	$sql .=  $crlf;
	fwrite($plik_sql, $sql);

	$res = mysql_list_tables($db_name);
	while($row = mysql_fetch_array($res)) {
		$table_name = $row[0];
		$table_fields = array();
		$sql  = '#' . $crlf . '# Struktura tabeli `' . $table_name . '`' . $crlf . '#' . $crlf . $crlf;
		if (SQL_DROP) {
			// dodawanie DROP TABLE;
			$sql .= 'DROP TABLE IF EXISTS `' . $table_name . '`;' . $crlf;
		}
		$sql .= 'CREATE TABLE ';
		if (SQL_IFNE) {
			// dodanie IF NOT EXISTS;
			$sql .= 'IF NOT EXISTS ';
		}
		$sql .= '`' . $table_name . '` ( ' . $crlf;

		$res2 = mysql_query('SHOW FIELDS FROM `' . $table_name . '`');
		while($fields = mysql_fetch_array($res2)) {
			$sql .= '   ';
			$sql .= '`'.$fields['Field'].'`' . ' ' . $fields['Type'];
			if (!empty($fields['Default'])) {
				$sql .= ' DEFAULT \'' . $fields['Default'] . '\'';
			}
			if ($fields['Null'] != 'Yes') {
				$sql .= ' NOT NULL';
			}
			if (!empty($fields['Extra'])) {
				$sql .= ' ' . $fields['Extra'];
			}
			$sql .= ',' . $crlf;
			$table_fields[] = $fields['Field'];
		}
		$index = '';

		$res2 = mysql_query('SHOW KEYS FROM `' . $table_name . '`');
		while ($keys = mysql_fetch_assoc($res2)) {
			$kname = $keys['Key_name'];
			if(($kname != 'PRIMARY') && ($keys['Non_unique'] == 0)) {
				$kname = 'UNIQUE|' . $kname;
			}
			$index[$kname] = array();
			$index[$kname][] = $keys['Column_name'];
		}
		// zliczenie wszystkich kluczow
		$fields = @count($index);
		$i = 1;
		while(list($n, $columns) = @each($index)) {
			if ($n == 'PRIMARY') {
				$sql .= '   PRIMARY KEY (`' . implode($columns, '`, `') . '`)';
			} else if (substr($n, 0, 6) == 'UNIQUE') {
				$sql .= '   UNIQUE `' . substr($n, 7) . '` (`' . implode($columns, '`, `') . '`)';
			} else {
				$sql .= '   KEY `' . $n . '` (`' . implode($columns, '`, `') . '`)';
			}
			// dodajemy , jesli klucz ni jest ostatni
			$sql .= ($fields == $i) ? '' : ', ';
			$sql .= $crlf;
			$i++;
		}
		$sql .= ')';

		$res2 = mysql_query('SHOW TABLE STATUS LIKE `' . $table_name . '`');
		$keys = mysql_fetch_assoc($res2);
		// rodzaj wykorzystywanego mechanizmu
		$sql .= ' ENGINE='.$keys['Engine'];
		// domyslne kodowanie tabeli
		$char = explode('_', $keys['Collation']);
		$sql .= ' DEFAULT CHARSET='.$char[0];
		$sql .= ' COLLATE='.$keys['Collation'];

		// dodanie wartosci AUTO_INCREMENT
		if(SQL_AUTO)
			$sql .= ' AUTO_INCREMENT='.$keys['Auto_increment'];

		$sql .= ';' . $crlf.$crlf;
		fwrite($plik_sql, $sql);

		$d_res = mysql_query('SELECT * FROM `' . $table_name . '`');
		// gdy rezultat zapytania = 0 oznacza, e zakoczyo si bdem, czyli nie ma zadnego rekordu w tabeli;
		if (mysql_num_rows($d_res) == 0) {
			$sql = '#' . $crlf . '# Brak danych z tabeli `' . $table_name . '`' . $crlf . '# Tabela jest pusta' . $crlf . '#' . $crlf;
		} else {
			$sql = '#' . $crlf . '# Dane z tabeli `' . $table_name . '`' . $crlf . '#' . $crlf . $crlf;
		}
		fwrite($plik_sql, $sql);

		while ($data = mysql_fetch_array($d_res)) {
			$sql = 'INSERT INTO `' . $table_name . '` ';
			if (SQL_FULL) {
				// pelne dodania danych;
				$sql .= '(`' . implode('`, `', $table_fields) . '`) ';
			}
			$sql .= 'VALUES (';
			$field_count = count($table_fields);
			$f_data = array();
			for ($i = 0; $i < $field_count; $i++) {
				$data[$i] = addslashes($data[$i]);						// zamiana ' " \ na \' \" \\ w danych z komorki
				$data[$i] = eregi_replace("\r\n", '\r\n', $data[$i]); 	// zamiana enetera i konca lini na \r\n;
				$f_data[] .= '\'' . $data[$i] . '\'';
			}
			$sql .= implode(', ', $f_data);
			$sql .= ');' . $crlf;
			fwrite($plik_sql, $sql);
		}
		$sql = $crlf . $crlf;
		fwrite($plik_sql, $sql);
	}
	$log_sql .= time_log() . "Zakoczenie pobierania danych z bazy i tworzenia zapytania sql<br>";
	$time_end = getmicrotime(); 	// czas zakonczenia tworzenia backupa;
	$time_gen = round($time_end - $time_start, 3); 	// czas tworzenia backupu (pliku sql z zapytaniami), 3 miejsca po ,;
	$sql  = '# -------------------------------------------------' . $crlf;
	$sql .= '#  Plik wygenerowano dnia ' . $data_czas . ' GMT' . $crlf;
	$sql .= '#  w czasie ' . $time_gen . ' s.' . $crlf;
	$sql .= '# =================================================' . $crlf;
	$sql .= '#             backup_db 1.0 by MalCom' . $crlf;
	$sql .= '#  Copyright (c) 2005 MalCom. All rights reserved.' . $crlf;
	$sql .= '# =================================================' . $crlf;
	fwrite($plik_sql, $sql);
	flock($plik_sql, 3);
	fclose($plik_sql);
	$log_sql .= time_log() . "Zamknicie pliku sql <b>$nazwa_pliku</b><br>";
	$db_disconnect = @mysql_close($db_connect);
	if (!$db_disconnect) {
		$log_sql .= time_log() . "<font color=red>Nie mona zakoczy poczenia z serwerem MySQL<font><br>";
	} else {
	$log_sql .= time_log() . "Zakoczono poczenie z serwerem MySQL<br>";
	}
	$kopia_sql = true;
	$size_sql = filesize($nazwa_pliku);		// rozmiar sqla;
	$size_sql = round($size_sql/1024, 2);	// rozmiar pliku w KB, 2 miejsca po przecinku;
// koniec wrzucania danych z bazy do pliku;
} else {
	// nie polaczono sie z baza; wstrzymaj wykonywanie backupa tj., wysylanie pliku, bo nie istnieje;
	$kopia_sql = false;
	$log_sql .= time_log() . "<font color=red><b>Wstrzymano wykonywanie backupa!</b></font><br>";
}

// jesli kopie sql wykonano wtedy mozna dzialac dalej, tj, skompresowac i wyslac na maila i ftpa;
if ($kopia_sql) {

// kompresja gzip //
if (GZIP_FILE) {
	$log_gzip .= time_log() . "Rozpoczto kompresj pliku sql do gz<br>";
	$plik_sql = fopen($nazwa_pliku, "r");
	$plik_gz = gzopen($nazwa_pliku . ".gz", "w9");
	while (!feof($plik_sql)) {
		$buffer = fread($plik_sql, 4096);
		gzwrite($plik_gz, $buffer, 4096);
	}
	fclose($plik_sql);
	gzclose($plik_gz);
	$log_gzip .= time_log() . "Zakoczono kompresj pliku<br>";
	unlink($nazwa_pliku);	// usun niepotrzebny plki sql;
	$nazwa_pliku = $nazwa_pliku . ".gz";	// nowa nazwa pliku;
	clearstatcache(); 						// czysci cache statystki pliku;
	$size_bac = filesize($nazwa_pliku);		// rozmiar pliku backupa;
	$size_bac = round($size_bac/1024, 2);	// rozmiar pliku w KB, 2 miejsca po przecinku;
	$wspol = ($size_bac * 100)/$size_sql;
	$wspol = round(100 - $wspol, 0);		// wspolczynki kompresji w %;
	$log_gzip .= "                  Skompresowany plik: <b>$nazwa_pliku</b><br>";
	$log_gzip .= "                   Rozmiar orginalny: <b>$size_sql KB</b><br>";
	$log_gzip .= "                Rozmiar po kompresji: <b>$size_bac KB</b><br>";
	$log_gzip .= "              Wspczynnik kompresji: <b>$wspol %</b><br>";
} else {
	$size_bac = $size_sql;
}

// wysylka na maila //
if (SEND_EMAIL) {
	$boundary = "-->=MESS_P5V4JHGM_141F4NQXXH=<_";	//SEPARATOR
	$log_email .= time_log() . "Przygotowywanie treci emaila i nagwkw<br>";
	// tresc emaila;
	$message  = $crlf;
	$message .= ' Kopia bazy MySQL wygenerowana przez backup_db 1.0' . $crlf;
	$message .= ' =================================================' . $crlf;
	$message .= '                 Host: ' . $sql_host . $crlf;
	$message .= '                   IP: ' . $sql_ip . $crlf;
	$message .= ' -------------------------------------------------' . $crlf;
	$message .= '    Zrzut bazy danych: ' . $db_name . $crlf;
	$message .= '         Wygenerowano: ' . $data_czas . ' GMT' . $crlf;
	$message .= '             w czasie: ' . $time_gen . ' s.' . $crlf;
	$message .= '          Rozmiar sql: ' . $size_sql . ' KB' . $crlf;
	$message .= '      Rozmiar backupu: ' . $size_bac . ' KB' . $crlf;
	$message .= '  Wspczyn.kompresji: '.((GZIP_FILE) ? ($wspol.' %') : 'GZIP wy.') . $crlf;
	$message .= '  Nazwa pliku backupa: ' . $nazwa_pliku . $crlf;
	$message .= ' =================================================' . $crlf;
	$message .= '             Powered by backup_db 1.0' . $crlf;
	$message .= '     backup_db (c) MalCom, malcom[at]o2[dot]pl' . $crlf;
	$message .= '  Copyright (c) 2005 MalCom. All rights reserved.' . $crlf;
	$message .= ' =================================================' . $crlf;

	// naglowek maila;
	$head  = "From: $e_name <$e_mail>\n";
	$head .= "Reply-To: $e_mail\n";
	$head .= "X-Mailer: backup_db\n";		// program wysylajacy poczte;
	$head .= "X-Sender: PHP\n";
	$head .= "Return-Path: <$e_mail>\n";	// adres zwrotny dla bledow;
	$head .= "MIME-Version: 1.0\n";
	$head .= "Content-Type: multipart/mixed; boundary=\"$boundary\"\n";
	$head .= "X-Attachments: $nazwa_pliku;\n\n";	// lista zalaczonych plikow;
	// sformatowana wiadomosc  maila;
	$mesg  =  "--" . $boundary . "\n";
	$mesg .= "Content-Type: text/plain; charset=ISO-8859-2\n";
	$mesg .= "Content-Transfer-Encoding: 8bit\n\n";
	$mesg .= $message . "\n";
	$mesg .=  "--" . $boundary . "\n";
	$mesg .= "Content-Type: application/octet-stream; name=\"$nazwa_pliku\"\n";
	$mesg .= "Content-Transfer-Encoding: base64\n";
	$mesg .= "Content-Disposition: attachment; filename=\"$nazwa_pliku\"\n\n";
	// zakodowany w base64 plik zalacznika;
	//$mesg .= "zakodowany base kod \n";
	$log_email .= time_log() . "Rozpoczto kodowanie pliku zacznika <b>$nazwa_pliku</b><br>";
	$plik = fopen($nazwa_pliku, "r");

	// najlepsze rozwiazanie
	// ---
	// $plik = fread($fd, filesize($file));
	// $encoded = chunk_split(base64_encode($plik));
	// ---
	// niestety nie sprawdza sie z duzymi plikami, funkcja chunk_split wymaga
	// wtedy za duzo pamieci i nastepuje przekroczenie dopuszczalnego limitu
	// rozwiazaniem tego jest nastepujace
	// pobieranie 60B z pliku i zakodowanie, i wstawienie '\n';
	// przy takim ustawieniu pobieranych danych na dokladnie 60B, wynikowy kod
	// calosci jest dokladnie taki sam jak przy uzyciu chunk_split, rozni sie
	// jedynie formatowaniem, dlugoscia lini, w tym przypadku jest o 4 znaki dluzsza...
	// przy pobieraniu innej ilosci znakow z pliku i kodowaniu calosc uleglaby
	// zmianie, mimo pominiecia wstawianych w takim przypadku dodatkowych 2B na
	// koncu kazdej lini. Nie dosc ze wynik nawet przy pominieciu tych dodatkowych
	// znakow sie roznil, to jezcze calosc miala by wiekszy rozmiar, 2B na linie,
	// co przy duzych plikach, daloby sie odczuc ;)

	while (!feof($plik)) {
		$buffer = fread($plik, 60);
		$mesg .= base64_encode($buffer) . "\n";
	}
	fclose($plik);
	$log_email .= time_log() . "Zakoczono kodowanie pliku zalacznika<br>";

	$mesg .= "\n";
	$mesg .= "--" . $boundary . "-- \n";	// pamietamy dwa minusy na poczatku i na koncu;

	$log_email .= time_log() . "Wysyanie e-maila z backupem na adres <b>$e_mail</b><br>";
	// wysylanie maila
	$email_result = mail($e_mail, $e_temat, $mesg, $head);
	if ($email_result) {
		$log_email .= time_log() . "Pomylnie wysano e-mail z backupem<br>";
	} else {
		$log_email .= time_log() . "<font color=red>Nie mona wysa e-maila z backupem</font><br>";
	}
}

// wysylka na ftp'a //
if (SEND_FTP) {

	// jak wyl usuwanie poprzedniej kopi z ftpa to dodanie do nazwy daty [data] - w przyszlosci //
	$nazwa_pliku_ftp = $nazwa_pliku;

	// ustaw podstawowe poczenie;
	$ftp_conn = @ftp_connect($ftp_server);
	if ($ftp_conn) {
		$log_ftp .= time_log() . "Nawizano poczenie z serwerem FTP<br>";
		$log_ftp .= time_log() . "Host: <b>$ftp_host</b>, IP: <b>$ftp_ip</b><br>";
		// logowanie do ftp'a;
		$log_ftpin_result = @ftp_login($ftp_conn, $ftp_user_name, $ftp_user_pass);
		if ($log_ftpin_result) {
			$log_ftp .= time_log() . "Zalogowano si jako user <b>$ftp_user_name</b><br>";
			$ftp_polaczenie = true;	// polaczono i zalogowano poprawnie;
		} else {
			$log_ftp .= time_log() . "<font color=red>Nie mona zalogowa si jako user <b>$ftp_user_name</b></font><br>";
		}
	} else {
		$log_ftp .= time_log() . "<font color=red>Nie mona nawiza poczenia z serwerem <b>$ftp_server</b></font><br>";
		$log_ftp .= time_log() . "Host: <b>$ftp_host</b>, IP: <b>$ftp_ip</b><br>";
	}
	// jesli placzono i zalogowano to wykonuj polecenia ftp...
	if ($ftp_polaczenie) {

		$ftp_sciezka_default = '/backup_db'; 	// standardowa sciezka do backupa;
		if (empty($ftp_sciezka)) { $ftp_sciezka = $ftp_sciezka_default; }
		$ftp_zmien_kat_result = @ftp_chdir($ftp_conn, $ftp_sciezka);
		if(!$ftp_zmien_kat_result) {
			$log_ftp .= time_log() . "<font color=red>Nie mona zmieni biecego katalogu na <b>$ftp_sciezka</b></font><br>";
			// nie mozna zmienic sciezki to zmien na domyslny;
			// sprobuj utworzyc kat domyslny, jesli sie nie uda znaczy ze istnieje;
			$ftp_utworz_default_result = @ftp_mkdir($ftp_conn, $ftp_sciezka_default);
			if(!$ftp_utworz_default_result) {
				//if(!$ftp_sciezka_def) {
					//jesli juz probowano zminic na domyslny to nie wyswietlaj ze znaleziono
					$log_ftp .= time_log() . "Znaleziono katalog domylny <b>$ftp_sciezka_default</b><br>";
				//}
			} else {
				$log_ftp .= time_log() . "Utworzono katalog domylny <b>$ftp_sciezka_default</b><br>";
			}
			// zmien na domyslny
			$ftp_zmien_kat_default_result = @ftp_chdir($ftp_conn, $ftp_sciezka_default);
			if(!$ftp_zmien_kat_default_result) {
				$log_ftp .= time_log() . "<font color=red>Nie mona zmieni biecego katalogu na <b>$ftp_sciezka_default</b></font><br>";
			} else {
				$log_ftp .= time_log() . "Zmieniono biecy katalog na <b>$ftp_sciezka_default</b><br>";
			}
		} else {
			$log_ftp .= time_log() . "Zmieniono biecy katalog na <b>$ftp_sciezka</b><br>";
		}
		// zmien na domyslny, ale tylko jesli sciezka nie byla pusta na poczatku,
		// bo jesli byla to juz probowano zmiany na domyslny


		$ftp_kat = @ftp_pwd($ftp_conn);
		if (!$ftp_kat) { $ftp_kat = '<font color=red>[bd odczytu]</font'; }
		$log_ftp .= time_log() . "Biecy katalog to <b>$ftp_kat</b><br>";
		//wyslanie pliku
		$log_ftp .= time_log() . "Rozpoczto transfer pliku backupa do katalogu biecego<br>";
		$ftp_upload = @ftp_put($ftp_conn, $nazwa_pliku_ftp, $nazwa_pliku, FTP_BINARY);
		if (!$ftp_upload) {
			$log_ftp .= time_log() . "<font color=red>Nie mona wysa pliku na serwer FTP</font><br>";
		} else {
			$log_ftp .= time_log() . "Pomylnie zakoczono transfer pliku backupa<br>";
			$log_ftp .= time_log() . "Przesano plik <b>$nazwa_pliku_ftp</b> do katalogu <b>$ftp_kat</b><br>";
		}
		// zamknij strumie FTP
		$ftp_disconn = ftp_close($ftp_conn);
		if (!$ftp_disconn) {
			$log_ftp .= time_log() . "<font color=red>Nie mona zakoczyc poczenia z serwerem FTP</font><br>";
		 } else {
		 	$log_ftp .= time_log() . "Zakoczono poczenie z serwerem FTP<br>";
		 }
	}
}

// sprawdz czy poprawnie wyslano na emial i ftp;
if ( (SEND_EMAIL && !$email_result) || (SEND_FTP && !$ftp_upload) ) {
	// nie wyslano do wszystkich miejsc docelowych;
	$log_send  = time_log() . "<font color=red>Nie wysano backupa do wszystkich miejsc docelowych</font><br>";
} else {
	$wyslano = true;	// wyslano wszedzie poprawnie;
	$log_send  = time_log() . "<font color=green><b>Pomylnie wysano backup do wszystkich miejsc docelowych</b></font><br>";
}

// usuwanie plikow z locala, tymczasow //
 // 0 -nigdy nie usuwaj;
 // 1 -zawsze usun, po zakonczeniu dzialania skryptu niezaleznie od wyniku;
 // 2 -usun tylko jesli wyslano do wszytskich miejsc docelowych;
if (DEL_TMP == 0) $usun = false;
if (DEL_TMP == 1) $usun = true;
if ((DEL_TMP == 2) && $wyslano) $usun = true;

// usuwanie
if ($usun) {
	$usun_result = 	unlink($nazwa_pliku);	// usuwanie pliku;
	if (!$usun_result) {
		$log_del  = time_log() . "<font color=red>Nie mona usun pliku z lokalnego serwera</font><br>";
	} else {
		$log_del  = time_log() . "Pomyslnie usunito plik z lokalnego serwera<br>";
	}
}

}
$log_end = time_log() . "Zakoczono wykonywanie backupa [skryptu]<br>";

// stan backupa //
if (!$kopia_sql) {
	$stan = "<font color=red>Wstrzymano wykonywanie backupa -> [sprawdz log]</font>";
} else if ($kopia_sql && $wyslano && !(SEND_FTP && !$ftp_zmien_kat_result) && !($usun && !$usun_result)) {
	$stan = "Wykonano poprawnie wszystkie instrukcje";
} else {
	$stan = "<font color=blue>Wykonano instrukcje z bdami -> [sprawdz log]</font>";
}

// Raporty //
$raport  = $crlf;
$raport .= '  Raport z tworzenia backupu bazy MySQL<br>';
$raport .= ' ===========================================================<br>';
$raport .= '     Baza danych: <b>' . $db_name . '</b><br>';
$raport .= '            Host: <b>' . $sql_host . '</b><br>';
$raport .= '              IP: <b>' . $sql_ip . '</b><br>';
$raport .= ' -----------------------------------------------------------</b><br>';
$raport .= '      Wsyka e-mailem: <b>'.((SEND_EMAIL) ? ('tak</b><br>               E-mail: <b>'.$e_mail) : 'nie').'</b><br>';
$raport .= '       Wysyka na FTP: <b>'.((SEND_FTP) ? ('tak</b><br>                 Host: <b>'.$ftp_host) : 'nie').'</b><br>';
$raport .= '       Kompresja GZIP: <b>'.((GZIP_FILE) ? 'tak' : 'nie') . '</b><br>';
$raport .= '   Usu plik z lokala: <b>'. DEL_TMP .'</b> [0-nigdy/ 1-zawsze/ 2-po wyslaniu]<br>';
$raport .= ' -----------------------------------------------------------</b><br>';
$raport .= '      dodanie DROP TABLE: <b>'.((SQL_DROP) ? 'tak' : 'nie') . '</b><br>';
$raport .= '   dodanie IF NOT EXISTS: <b>'.((SQL_IFNE) ? 'tak' : 'nie') . '</b><br>';
$raport .= '  pelne zapytania danych: <b>'.((SQL_FULL) ? 'tak' : 'nie') . '</b><br>';
$raport .= ' -----------------------------------------------------------</b><br>';
$raport .= '         Raport pelny: <b>'.((RAPORT_FULL) ? 'tak' : 'nie') . '</b><br>';
$raport .= '     Raport www/email: <b>'.((RAPORT_WWW) ? 'tak' : 'nie') .'</b>/<b>'. ((RAPORT_EMAIL) ? 'tak' : 'nie') .'</b> ';
$raport .= ((RAPORT_EMAIL) ? '['.$e_rap_mail.']' : '') . '<br>';
$raport .= ' -----------------------------------------------------------</b><br>';
$raport .= '    Zrzut bazy danych: <b>' . $db_name . '</b><br>';
$raport .= '         Wygenerowano: <b>' . $data_czas . ' GMT</b><br>';
$raport .= '             w czasie: <b>' . $time_gen . ' s.</b><br>';
$raport .= '          Rozmiar sql: <b>' . $size_sql . ' KB</b><br>';
$raport .= '      Rozmiar backupu: <b>' . $size_bac . ' KB</b><br>';
$raport .= '  Wspczyn.kompresji: <b>'.((GZIP_FILE) ? ($wspol.' %') : 'GZIP wy.').'</b><br>';
$raport .= '  Nazwa pliku backupa: <b>' . $nazwa_pliku . '</b><br>';
$raport .= ' ===========================================================</b><br>';
$raport .= '  Stan backupu:<br>';
$raport .= '        -> ' . $stan . '<br>';

// pelny raport z logami //
if (RAPORT_FULL) {
	$raport .= ' -----------------------------------------------------------' . $crlf;
	$raport .= '  Logi z tworzenie backupa:' . $crlf;
	$raport .= '        -> ' . $crlf;
	$raport .= $log_start;
	$raport .= $log_sql;
	$raport .= $log_gzip;
	$raport .= $log_email;
	$raport .= $log_ftp;
	$raport .= $log_send;
	$raport .= $log_del;
	$raport .= $log_end;
	$raport .= time_log() . "Generowanie raportu i wysyka na emaila / wywietlnie na www<br>";
}

$time_skrypt_end = getmicrotime();
$time_skrypt = round($time_skrypt_end - $time_skrypt_start, 3); 	// czas wykonywania skryptu;
$raport .= ' -----------------------------------------------------------' . $crlf;
$raport .= '        -> czas pracy skryptu: ' . $time_skrypt .' s.'. $crlf;
$raport .= ' ===========================================================' . $crlf;
$raport .= '  Powered by backup_db 1.0 (c) MalCom, malcom[at]o2[dot]pl' . $crlf;
$raport .= '       Copyright (c) 2005 MalCom. All rights reserved.' . $crlf;
$raport .= ' ===========================================================' . $crlf;
// konwersja do iso-2
$znaki     = array("", "", "", "<br>");
$znaki_iso = array("", "", "", "\r\n");
$raport = str_replace($znaki, $znaki_iso, $raport);

// raport na emaila //
if (RAPORT_EMAIL) {
	// konwersja raportu z html na text;
	$rapotr_email = str_replace("<br>", $crlf, $raport);
	$rapotr_email = strip_tags($rapotr_email);		// usuniecie reszty tagow;

	// naglowek maila;
	$rap_head  = "From: $e_rap_name <$e_rap_mail>\n";
	$rap_head .= "Reply-To: $e_rap_mail\n";
	$rap_head .= "X-Mailer: backup_db\n";			// program wysylajacy poczte;
	$rap_head .= "X-Sender: PHP\n";
	$rap_head .= "Return-Path: <$e_rap_mail>\n";	// adres zwrotny dla bledow;
	$rap_head .= "MIME-Version: 1.0\n";
	$rap_head .= "Content-Type: text/plain; charset=ISO-8859-2\n";
	$rap_head .= "Content-Transfer-Encoding: 8bit\n\n";

	// wysylanie maila z raportem;
	$rap_email_result = @mail($e_rap_mail, $e_rap_temat, $rapotr_email, $rap_head);
}
// wyswietl raport na www //
if (RAPORT_WWW) {
	echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">';
	echo '<html><head>';
	echo '<meta http-equiv="Content-Language" content="pl">';
	echo '<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-2">';
	echo '<meta name="Author" content="MalCom malcom[at]o2[dot]pl">';
	echo '<title>backup_db 1.0 by MalCom</title>';
	echo '</head><body>';
	echo '<div align="center"><center>';
	echo '<table border="0" cellpadding="0" cellspacing="3">';
	echo '<tr><td><pre>';
	echo $raport;
	echo '</pre></td></tr>';
	echo '</table>';
	echo '</center></div>';
	echo '</body></html>';
}

?>
